2010-06-21  Jb Evain  <jbevain@novell.com>

	* CharUnicodeInfo.cs: make static.

2010-06-21  Jb Evain  <jbevain@novell.com>

	* CultureNotFoundException.cs: add it to Moonlight.

2010-06-21  Jb Evain  <jbevain@novell.com>

	* TimeSpanStyles.cs: add to Moonlight.

2010-04-19  Zoltan Varga  <vargaz@gmail.com>

	* CompareInfo.cs (IndexOf): Return startIndex instead of 0 for empty strings.
	Fixes #597604.

2010-03-16  Jb Evain  <jbevain@novell.com>

	* CultureInfo.cs, CompareInfo.cs, Calendar.cs: use MOONLIGHT symbol
	to disambiguate MonoTouch and Moonlight code.

2010-02-28 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* CultureNotFoundException.cs: new 4.0 type.
	* CultureTypes.cs: add [Obsolete] for 2 values.
	* TimeSpanStyles.cs: new 4.0 enum.

2009-12-09  Jb Evain  <jbevain@novell.com>

	* StringInfo.cs: default constructor falls back to an empty string info.

2009-11-04  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* CultureInfo.cs: Allow neutral cultures, and fix zh-Hans/zh-Hant
	- they're stored internally as zh-chs/zh-cht, and only visible as
	zh-Hans/zh-Hant. zh-CHS/zh-CHS are invalid cultures in SL.

2009-10-29  Sebastien Pouliot  <sebastien@ximian.com>

	* CompareInfo.cs: Add/fix CompareOptions validations. Reduce code
	duplication in Compare methods (wrt CompareOptions). Fix 
	calculation bug	in Compare(string,int.string,int,CompareOptions).

2009-10-27  Sebastien Pouliot  <sebastien@ximian.com>

	* TextInfo.cs: Avoid allocating zero-length strings in ToLower 
	and ToUpper methods

2009-10-14  Jonathan Pryor  <jpryor@novell.com>

	* CultureInfo.cs: Re-add GetCultures() to the MonoTouch profile.

2009-10-14  Sebastien Pouliot  <sebastien@ximian.com>

	* CultureInfo.cs: Refactor to reduce unsafe methods/scope.

2009-10-07  Sebastien Pouliot  <sebastien@ximian.com>

	* CompareInfo.cs: Don't allow MONO_DISABLE_MANAGED_COLLATION
	override for Moonlight and move all icalls together so they
	can be #if-ed out.

2009-09-23  Sebastien Pouliot  <sebastien@ximian.com>

	* Calendar.cs: Don't expose AlgorithmType property in NET_2_1
	* CultureInfo.cs: Don't expose CultureTypes in NET_2_1
	* NumberFormatInfo.cs: Don't expose NativeDigits in NET_2_1
	* GregorianCalendar.cs, HebrewCalendar.cs, HijriCalendar.cs,
	JapaneseCalendar.cs, KoreanCalendar.cs, TaiwanCalendar.cs,
	ThaiBuddhistCalendar.cs, UmAlQuraCalendar.cs: Don't expose 
	AlgorithmType property in NET_2_1

2009-07-26  Miguel de Icaza  <miguel@novell.com>

	* Calendar.cs: Do not add internal abstract methods to the
	Calendar class, it prevents derived classes from existing. 

2009-05-21  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : it seems that zh-Hant and zh-Hans are introduced
	  as almost alias  of zh-CHS/zh-CHT in vista and some new windows.
	  Add hacky support for them.

2009-01-07  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : Fixed bug #462957. With empty target string it
	  should always return 0.

2008-08-14  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : applied patch by Robert Jordan,
	  fixed bug #402128. Create uninitialized parent culture
	  when required.

2008-07-28  Marek Safar <marek.safar@gmail.com>

	* GregorianCalendar.cs: Delay DateTime .cctor invocation.

2008-07-03  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* TextInfo.cs: Fix exceptions
	* StringInfo.cs
	* SortKey.cs:
	* RegionInfo.cs:
	* NumberFormatInfo.cs:
	* CultureInfo.cs:
	* CompareInfo.cs:
	* CharUnicodeInfo.cs: Fix parameter names

2008-07-03  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* UmAlQuraCalendar.cs:
	* ThaiBuddhistCalendar.cs
	* TaiwanCalendar.cs:
	* PersianCalendar.cs:
	* KoreanCalendar.cs:
	* JulianCalendar.cs:
	* JapaneseCalendar.cs:
	* HijriCalendar.cs:
	* HebrewCalendar.cs:
	* GregorianCalendar.cs:
	* EastAsianLunisolarCalendar.cs:
	* Calendar.cs: Fix parameter names

2008-06-28  Zoltan Varga  <vargaz@gmail.com>

	* CompareInfo.cs: Add a cache of SimpleCollator objects.

2008-01-13  Eyal Alaluf <eyala@mainsoft.com>

	* NumberFormatInfo.cs: Defined internal "Raw" APIs that do not clone the
	  internal array members in order to improve performance of custom ToString.

2008-01-06  Zoltan Varga  <vargaz@gmail.com>

	* CultureInfo.cs: Add a 'cached_serialized_form' field.
	
	* CultureInfo.cs NumberFormatInfo.cs DateTimeFormatInfo.cs TextInfo.cs: Make
	sure the components of a read-only culture object are read-only as well.

2007-12-28  Gert Driesen  <drieseng@users.sourceforge.net>

	* CultureInfo.cs: Added internal CreateCulture method, which is used
	by the runtime to creating CultureInfo instances for AssemblyName.

2007-11-21  Atsushi Enomoto  <atsushi@ximian.com>

	* NumberFormatInfo.cs :
	  NativeDigits and DigitSubstitution are [ComVisible(false)].

2007-09-10  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : implemented SetAllDateTimePatterns().

2007-09-10  Atsushi Enomoto  <atsushi@ximian.com>

	* NumberFormatInfo.cs : added NativeDigits and DigitSubstitution.

2007-09-06  Marek Habersack  <mhabersack@novell.com>

	* DateTimeFormatInfo.cs: minimal implementation of
	AbbreviatedMonthGenitiveNames, MonthGenitiveNames and
	NativeCalendar name properties.

2007-08-24  Zoltan Varga  <vargaz@gmail.com>

	* CalendricalCalculations.cs: Fix a warning.

2007-07-17  Atsushi Enomoto  <atsushi@ximian.com>

	* CalendricalCalculations.cs, JulianCalendar.cs :
	  true fix for bug #81783. GetMonths() should consider month part
	  going beyond 12.

2007-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* StringInfo.cs : implemented 2.0 members.

2007-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* UmAlQuraCalendar.cs : forgot to implement it.

2007-07-10  Atsushi Enomoto  <atsushi@ximian.com>

	* HijriCalendar.cs ThaiBuddhistCalendar.cs HebrewCalendar.cs
	  GregorianCalendar.cs KoreanCalendar.cs JulianCalendar.cs :
	  implemented ToFourDigitYear(), actually base implementation mostly
	  works as is.

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : 1.x build fix.

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : implemented GetConsoleFallbackUICulture and
	  CultureTypes (it is awful indeed). Fix ComVisibles.
	  implemented InstalledUICulture, as what matches the best I think is
	  the one for BootstrapCultureID.

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : another hack, KeyboardLayoutId.

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs :
	  hacked IetfLanguageTag and GetCultureInfoByIetfLanguageTag().

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : Name.
	* PersianCalendar.cs : missing members.
	* NumberFormatInfo.cs HijriCalendar.cs CultureInfo.cs TextInfo.cs
	  HebrewCalendar.cs ThaiBuddhistCalendar.cs GregorianCalendar.cs
	  KoreanCalendar.cs JulianCalendar.cs TaiwanCalendar.cs
	  JapaneseCalendar.cs DaylightTime.cs EastAsianLunisolarCalendar.cs
	  RegionInfo.cs TextElementEnumerator.cs : ComVisible cleanup.

2007-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : ICloneable.
	* GregorianCalendarTypes.cs CompareOptions.cs CultureTypes.cs
	  CalendarWeekRule.cs UnicodeCategory.cs : [Serializable].
	* ThaiBuddhistCalendar.cs GregorianCalendar.cs KoreanCalendar.cs
	  TaiwanCalendar.cs JapaneseCalendar.cs :
	  GetWeekOfYear() (base could be simply used). Removed unused code.

2007-07-02  Atsushi Enomoto  <atsushi@ximian.com>

	* UmAlQuraCalendar.cs
	  EastAsianLunisolarCalendar.cs
	  ChineseLunisolarCalendar.cs
	  TaiwanLunisolarCalendar.cs
	  JapaneseLunisolarCalendar.cs
	  KoreanLunisolarCalendar.cs : new 2.0 calendars.
	* Calendar.cs
	  HijriCalendar.cs HebrewCalendar.cs ThaiBuddhistCalendar.cs
	  GregorianCalendar.cs KoreanCalendar.cs JulianCalendar.cs
	  TaiwanCalendar.cs JapaneseCalendar.cs PersianCalendar.cs :
	  added GetLeapMonth().
	* CalendricalCalculations.cs : added some lunisolar calendar stuff.
	  mostly stubs.

2007-06-24  Gert Driesen  <drieseng@users.sourceforge.net>

	* CultureInfo.cs: Added new private ctors that takes value for 
	read-only bit as argument. In ContructInvariant, clone invariant 
	NumberFormatInfo and DateTimeFormatInfo when we're not creating a
	read-only CultureInfo, since they also should not be read-only.
	Changes are required to allow a writable invariant CultureInfo to be
	constructed. In GetCultures, use clone of InvariantCulture since it 
	must be not be read-only. In GetCultureInfo, always construct
	read-only CultureInfo's. Fixes part of bug #81930.

2007-06-01  Atsushi Enomoto  <atsushi@ximian.com>

	* Calendar.cs DateTimeFormatInfo.cs : 2.0 API fixes.
	* CalendricalCalculations.cs : fixed AddMonth() and AddYears() to
	  consider that the max days in the target month (for AddYears()
	  leap year month could matter). Fixed bug #81783.

2007-05-31  Rolf Bjarne Kvinge  <RKvinge@novell.com>

	* GregorianCalendar.cs: Change era names from C.E./Common Era 
	to AD/A.D.
	* DateTimeFormatInfo.cs: GetEra: search the abbreviated era names
	as well for the era, and return the era, not the index of the era 
	in the array.

2007-05-25  Atsushi Enomoto  <atsushi@ximian.com>

	* IdnMapping.cs : new 2.0 class.

2007-05-17  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : added roundtrip pattern (only in 2.0).

2007-05-15  Atsushi Enomoto  <atsushi@ximian.com>

	* RegionInfo.cs, CultureInfo.cs : in 2.0 RegionInfo could be created
	  from locale name. To support that, retrieve CultureInfo from name
	  and use its Territory name if exists.
	  RegionInfo.Equals() still uses lcid, but hash code is based on
	  region ID. Added GeoId, which represents unique region ID (which
	  is returned in 1.x GetHashCode()).

2007-04-17  Alp Toker  <alp@atoker.com>

	* DateTimeFormatInfo.cs: Provide set accessor for MonthNames.

2007-04-16  Marek Safar  <marek.safar@gmail.com>

	* PersianCalendar: Removed twoDigitYearMax field.

2007-03-25  Marek Safar  <marek.safar@gmail.com>

	* GregorianCalendar.cs, HebrewCalendar.cs, JapaneseCalendar.cs,
	HijriCalendar.cs, JapaneseCalendar.cs, JulianCalendar.cs,
	KoreanCalendar.cs, TaiwanCalendar.cs, ThaiBuddhistCalendar.cs:
	Removed twoDigitYearMax field.

2007-01-25  Chris Toshok  <toshok@ximian.com>

	* Calendar.cs, HijriCalendar.cs, ThaiBuddhistCalendar.cs,
	HebrewCalendar.cs, GregorianCalendar.cs, KoreanCalendar.cs,
	JulianCalendar.cs, PersianCalendar.cs:

	more serialization fixes.  the M_TwoDigitYearMax field we use
	appears to be called twoDigitYearMax in MS.NET.  rename it (and
	fix all the Calendar subclasses to use this naming).  Likewise
	with is_readonly (MS calls it m_isReadOnly).

	Also, the m_currentEraValue field I had originally placed in
	GregorianCalendar appears to be in Calendar (as running
	nunit-2.2.8-2.0 shows.)

	In GregorianCalendar, rename the M_CalendarType field to m_type
	and remove the extra field I added.
	
	The previous fix got nunit 2.4-2.0 running.  This change gets
	versions 2.2.8 and 2.4 of nunit running against both 1.1 and 2.0
	profiles.

2006-01-24  Chris Toshok  <toshok@ximian.com>

	[ these fix nunit built with MS .net 2.0, running on mono.  nunit
	apparently stores all manner of things in its resources ]
	
	* NumberFormatInfo.cs: add unused nativeDigits and
	digitSubstitution fields that MS serializes.

	* DateTimeFormatInfo.cs: serialization fixes.  MS apparently
	stores (and serializes) a couple of fields as ints, but exposes
	them to programmers as Enum's.
	
	* CompareInfo.cs: add unused m_name field that MS serializes.

	* GregorianCalendar.cs: add a couple of unused fields that MS serializes.

2007-01-22  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : there was a test which raises assertion failure
	  if there isn't paramName for ArgumentException. Quite odd one.

2007-01-12  Miguel de Icaza  <miguel@novell.com>

	* DateTimeFormatInfo.cs: Add support for shortest day names.
	Notice that there is no support in the runtime to actually load
	this information from any place.   So they are all english values.

2007-01-07  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : GetSortKey() does not allow Ordinal and 
	  OrdinalIgnoreCase in 2.0 (shuold be also prohibited in 1.x BTW).

2006-12-25  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : for OrdinalIgnoreCase, IndexOf() and LastIndexOf()
	  will use managed version (icalls for them are case sensitive).
	  Removed MonoTODOs.

2006-12-17  Igor Zelmanovich <igorz@mainsoft.com>

	* DateTimeFormatInfo.cs : added missing properties and methods.

2006-12-01  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : added some internal clone-less versions of
	  string[] properties and methods.

2006-11-27  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : fixed wrong || with && for OrdinalIgnoreCase.
	  Fixed bug #80056.

2006-11-10  Marek Safar  <marek.safar@gmail.com>

	* CultureInfo.cs (TextInfo): Construct a culture when is
	uninitialized. An issue exposed by previous change.

2006-11-09  Marek Safar  <marek.safar@gmail.com>

	* CompareInfo.cs: Cache full UseManagedCollation value;
	* CultureInfo.cs (Parent): Add caching to avoid re-creating culture info
	  every time when the property is used.
	* TextInfo.cs: Removed unused field.

2006-08-19  Miguel de Icaza  <miguel@novell.com>

	* CultureInfo.cs (GetCultureInfo): implement two of the 2.0
	overloads, as the vb code depends on this.

2006-07-03  Kornél Pál  <kornelpal@gmail.com>

	* CodePageDataItem.cs: Added.

2006-06-30  Zoltan Varga  <vargaz@gmail.com>

	* CultureInfo.cs: Add stubs for net 2.0 GetCultureInfo () methods.

2006-03-21  Atsushi Enomoto  <atsushi@ximian.com>

	* HebrewCalrndar.cs : simply use CCHebrewCalendar.last_day_of_month().
	  Patch by Yaacov Akiba Slama. Fixed bug #76252.

2006-03-20  Atsushi Enomoto  <atsushi@ximian.com>

	* HebrewCalrndar.cs : removed commented obsolete code.

2006-03-16  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : (ToUpper/ToLower) use InternalAllocateStr() and
	  pointers rather than StringBuilder.

2006-03-07  Peter Dennis Bartok  <pbartok@novell.com>

	* DateTimeFormatInfo.cs: Restored original field order to allow
	  some automatic locale fu to happen (mono unmanaged code relies 
	  on the field order to fill out DateTimeFormatInfo)

2006-03-02  Peter Dennis Bartok  <pbartok@novell.com>

	* DateTimeFormatInfo.cs: Switched (where possible) our internal
	  field names to match MS names. Added fields that MS has and we
	  don't. Fixes serialization issues with MS.
	* CultureInfo.cs, Calendar.cs, TextInfo.cs, 
	  GregorianCalenda.cs: Hiding internal attributes from serialization

2006-01-25  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : Clone() attempted to clone number and date time
	  formats, thus failed. Fixed bug #77347.

2005-12-08  Sebastien Pouliot  <sebastien@ximian.com> 

	* DaylightTime.cs: Fixed serialization to be compatible with MS FX.
	Pre-requisite to fix bug #76094.

2005-12-06  Sebastien Pouliot  <sebastien@ximian.com> 

	* DateTimeStyles.cs: ComVisible is only needed in 2.0.
	* TextInfo.cs: Added some 2.0 features that were needed (e.g. LCID)
	to implement serialization for another class. Added TODO on class for 
	deserialization (so it shows up in the status page).

2005-11-29  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : IsSortable() are static.
	* CharUnicodeInfo.cs : became non-static in RTM.
	* Calendar.cs : added support for Clone() and IsReadOnly.
	* HijriCalendar.cs ThaiBuddhistCalendar.cs HebrewCalendar.cs
	  GregorianCalendar.cs KoreanCalendar.cs JulianCalendar.cs
	  TaiwanCalendar.cs JapaneseCalendar.cs PersianCalendar.cs :
	  check IsReadOnly on every setter.

2005-11-14  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : added support for OrdinalIgnoreCase.

2005-10-31  Miguel de Icaza  <miguel@novell.com>

	* HijriCalendar.cs, HebrewCalendar.cs, JulianCalendar.cs,
	GregorianCalendar.cs, JapaneseCalendar.cs, Calendar.cs,
	TaiwanCalendar.cs, HijriCalendar.cs: Add
	CalendarAlgorithmType, MinSupportedDateTime, MaxSupportedDateTime
	properties. 

	* Added ComVisibleAttribute in a bunch of places, using the fully
	qualified name to speed up cut and paste.
	
2005-10-14  Ben Maurer  <bmaurer@ximian.com>

	* DateTimeFormatInfo.cs: Speed up GetAllDateTimePatterns by
	caching the result and then cloning it.

2005-10-10  Ben Maurer  <bmaurer@ximian.com>

	* DateTimeFormatInfo.cs: Rather than having a + ' ' + b, have a +
	" " + b. This lets us avoid 1) boxing the char and 2) calling
	char.ToString. Results in a fairly substantial savings on
	DateTime.Parse.

2005-09-21  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : switched to "managed collation by default" mode.

2005-08-30  Sebastien Pouliot  <sebastien@ximian.com>

	* CompareInfo.cs: Use Environment.internalGetEnvironmentVariable as
	the .cctor gets executed before the security manager is ready to be
	activated (and cause recursion with --security).

2005-08-17  Atsushi Enomoto  <atsushi@ximian.com>

	* RegionInfo.cs : unlocked CurrentRegion creation.

2005-08-16  Atsushi Enomoto  <atsushi@ximian.com>

	* RegionInfo.cs : removed extraneous icall wrappers.

2005-08-15  Atsushi Enomoto  <atsushi@ximian.com>

	* RegionInfo.cs : reimplemented to use unicode CLDR.

2005-08-14  Gert Driesen  <drieseng@users.sourceforge.net>

        * TextInfo.cs: For invariant culture, ListSeparator is a comma.

2005-08-12  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : GetAbbreviatedEraNames() and GetEra().

2005-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : lazy load OptionalCalendars (and always non-null).
	* DateTimeFormatInfo.cs : GetEraNames() should work.

2005-08-11  Atsushi Enomoto  <atsushi@ximian.com>

	* CultureInfo.cs : added BootstrapCultureID for RegionInfo.
	* RegionInfo.cs : implemented CurrentRegion. Added MonoTODOs.

2005-08-10  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : added IsSortable(). (NET_2_0)

2005-08-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* CompareInfo.cs: Marked UseManagedCollation internal to have API 
	match that of MS.NET.

2005-08-02  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs :
	  Added managed collation support. It won't be activated unless you 
	  explicitly set environment MONO_USE_MANAGED_COLLATION=yes.

2005-08-02  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : LastIndexOf() which takes startIndex without length
	  should use startIndex+1 as length.

2005-07-12  Atsushi Enomoto  <atsushi@ximian.com>

	* CompareInfo.cs : IndexOf(string, char, ...) overloads must not
	  specify start as 0. Use source.Length - 1 instead.

2005-06-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* NumberFormatInfo.cs: undo workaround for bug 55978 as it's not needed
	any more. This fixed bug #75396.

2005-06-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CultureInfo.cs: added internal method to check for a culture
	valid for formatting. Correctly get the calendar type.  Before
	it was always type 0. Thanks to Mcs for pointing this out.

2005-05-06  Miguel de Icaza  <miguel@novell.com>

	* CultureInfo.cs: Eliminate double-check lock always init the invariant_culture_info.

2005-05-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CultureInfo.cs: made a few variables 'volatile'. GetCultures now
	returns the InvariantCulture in the array. Fixes bug #72081.

2005-04-27  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : Some performance fixes. Avoid delegate.
	  Compute parent culture only once. Quick ASCII range check.

2005-04-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : extremely strict null check (which should not happen).

2005-04-17  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : Additional null check for Parent CultureInfo.

2005-04-06  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : To make new CultureInfo (127) as invariant, it should
	  not compare object Equals() against InvariantCulture.

2005-04-05  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : Fixed ToTitleCase() so that
	  - handle some titlecase characters in Latin ang Greek.
	  - it keeps "all title case" word as is ("ABC" does not become "Abc").
	  - it can handle such string like "1ABc".

2005-04-04  Atsushi Enomoto  <atsushi@ximian.com>

	* TextInfo.cs : implemented culture sensitive ToLower() and ToUpper()
	  which behaves exactly the same as MS.NET does.

2005-02-09  Lluis Sanchez Gual  <lluis@ximian.com>

	* CultureInfo.cs: Added field needed for serialization
	interoperability with MS.NET. Also fixed default value for
	the constructor.

2005-01-31  Atsushi Enomoto  <atsushi@ximian.com>

	* NumberFormatInfo.cs : allow zero length sizes. patch by Kazuki
	  Oikawa.

2005-01-20  Jackson Harper  <jackson@ximian.com>

	* HebrewCalendar.cs: Patch by Juan C. Olivares
	(juancri@tagnet.org) to implement 4 digit years and set the
	min year correctly.

2005-01-17  Atsushi Enomoto  <atsushi@ximian.com>

	* CharUnicodeInfo.cs : added new in 2.0 (kinda hacky).

2005-01-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CultureInfo.cs: the InvariantCulture returns false for
	IsNeutralCulture. Fixes bug #59716.

2004-12-13  Ben Maurer  <bmaurer@ximian.com>

	* CultureInfo.cs: Store TextInfo data. Hand it over to TextInfo.
	* TextInfo.cs: Rewrote props to use the textinfo data stored in
	unmanaged code.

2004-11-04  Zoltan Varga  <vargaz@freemail.hu>

	* CultureInfo.cs (Clone): Make the components of the culture read-write
	as well.

2004-10-14  Miguel de Icaza  <miguel@ximian.com>

	* TextInfo.cs (ToString) Fix the return value for ToString.

	(Add a new parameter: the CultureInfo, since we implemented things
	in terms of the CultureInfo in our runtime, and not the
	TextInfo). 

	(ToTitleCase): Fix to do title case for each word on the string
	per the spec.

Wed Jun 30 17:06:43 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* NumberFormatInfo.cs: workaround for bug 55978.

2004-06-17  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : check if pattern array is empty or not. Now
	  icall fills them as possible empty list.

2004-06-15  Gert Driesen <drieseng@users.sourceforge.net>

	* DateTimeFormatInfo.cs: added TODO for serialization
	* GregorianCalendar.cs:: added TODO for serialization
	* HebrewCalendar.cs: added TODO for serialization
	* HijriCalendar.cs: added TODO for serialization
	* JapaneseCalendar.cs: added TODO for serialization
	* JulianCalendar.cs: added TODO for serialization
	* KoreanCalendar.cs: added TODO for serialization
	* TaiwanCalendar.cs: added TODO for serialization
	* ThaiBuddhistCalendar.cs: added TODO for serialization

2004-06-08  Dick Porter  <dick@ximian.com>

	* CultureInfo.cs: Make calendar_data readonly, to match the
	const-ness in the runtime.

2004-05-28  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : In fact GetAllDateTimePatterns() returns
	  non-unique results.  Just reordered return values looking at MS
	  invariant behavior.

2004-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : 'U' is in fact the same as 'F' for pattern
	  strings. Thanks to kangaroo for the hint.

2004-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : Fixed longtimes and shorttimes (exchanged).

2004-05-27  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs : Added some string[] fields for
	  GetAllDateTimePatterns(char). The fields will be filled in metadata
	  and culture info table. Added improved patterns for 
	  GetAllDateTimePatterns() (right now works only for invariant).
	* CultureInfo.cs : Use InvariantInfo for InvariantCulture.

2004-05-26  Atsushi Enomoto  <atsushi@ximian.com>

	* DateTimeFormatInfo.cs :
	  hack implementation for GetAllDateTimePatterns().

2004-05-17  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: Invariant culture has the invariant culture as
	its parent....<insert joke about the south>. It is readonly so we
	can return this.
	
2004-05-17  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: Properify error messages when invalid lcid's are
	used.

2004-05-15  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: Initialize optional calendars. A pointer to an
	array of ints is passed back from the runtime to the CultureInfo
	object. The ints store the calendar type and any optional data
	needed to construct the calendar.
	
2004-05-14  Dick Porter  <dick@ximian.com>

	* HebrewCalendar.cs: Stubbed ToFourDigitYear()

	* HijriCalendar.cs: Stubbed HijriAdjustment

2004-05-13  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: You can access DateTimeFormat and NumberFormat
	from the invariant culture.
	
2004-05-13  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: DateTimeFormat and NumberFormat can not be
	accessed for neutral cultures.
	
2004-04-30  Dick Porter  <dick@ximian.com>

	* StringInfo.cs: 
	* TextElementEnumerator.cs: Implemented

2004-04-27  Jackson Harper <jackson@ximian.com>

	* CultureInfo.cs: Make specific names lower case, because all data
	in the culture info tables is lowercase.
	
2004-04-25  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* CultureInfo.cs: Call invariant String.ToLower
	* RegionInfo.cs: Call invariant String.ToUpper

2004-04-11  Atsushi Enomoto  <atsushi@ximian.com>

	* NumberFormatInfo.cs : All GetXXXGroupSizes() should not return
	  internal array. Return clone as MS.NET does.

	  There still looks somewhere breaking CurrentInfo.

2004-04-08  Lluis Sanchez Gual  <lluis@ximian.com>

	* CompareInfo.cs, CultureInfo.cs, NumberFormatInfo.cs, TextInfo.cs:
	Made those serializable-compatible with MS.NET: modified fields names to 
	match MS.NET ones, and in CultureInfo added a flag to control when a
	deserialized instance need to be initialized.

2004-04-07  Jackson Harper  <jackson@ximian.com>

	* CultureInfo.cs: Use new ICUless implementation in the runtime.
	* CompareInfo.cs: Get ICU name from a cultureinfo object instead
	of looking it up in the culture map.
	* RegionInfo.cs: Dont check if the LCID is neutral unless its not
	found in the switch. Avoids an icall.
	
2004-03-24  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* NumberFormatInfo.cs: this fixes bug #56000 for me. And it doesn't
	break anything as NumberFormatInfo is sealed.

2004-02-14  Atsushi Enomoto  <atsushi@ximian.com>

	* NumberFormatInfo.cs : CurrentInfo should not return clone every 
	  time (MS.NET returns the same object; try object.ReferenceEquals()).

2004-02-08 David Sheldon <dave-mono@earth.li>

	* NumberFormatInfo.cs: When parsing the percentages, put the data 
	  into PercentDecimalDigits/PercentGroupLengths, rather than trashing
	  the NumberDecimatDigits etc. This also means that the percent format
	  info gets set.

2004-01-27  David Sheldon <dave-mono@earth.li>

	* NumberFormatInfo.cs: InitPatterns: it seems that the patterns in 
	  ICU use digitPattern, not zeroPattern for the spaces after the 
	  decimal point. 

2004-01-12  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CultureInfo.cs: Parent returns null when lcid == parent_lcid. Fixes
	bug #52102.

2003-12-20 Ben Maurer  <bmaurer@users.sourceforge.net>

	* CompareInfo.cs: Replace blah == "" with blah.Length == 0.
	MUCH faster. Note, we dont need to check for nulls, because
	the properties were used in other places.

2003-12-19  Dick Porter  <dick@ximian.com>

	* CompareInfo.cs: Added assorted shortcuts when comparing empty
	strings.  Fixed offset and length range checks to flag when <0.
	Broke test that offset >= string length to match actual ms
	behaviour (sigh.)  Fixes bug 52310.

2003-12-06  Dick Porter  <dick@ximian.com>

	* CompareInfo.cs: Don't build strings in Compare, IndexOf and
	LastIndexOf methods.  Avoid the icall in IndexOf and LastIndexOf
	if the search parameter is a char and the CompareOptions include
	Ordinal.

2003-12-04  Dick Porter  <dick@ximian.com>

	* CompareInfo.cs: Implement the deserialization callback

	* CultureInfo.cs: Allow CompareInfo to see the CultureMap so that
	it can construct the ICU collator itself

2003-12-02  Dick Porter  <dick@ximian.com>

	* NumberFormatInfo.cs: Helper called by runtime locale
	construction from ICU.  Patch by Mohammad DAMT (mdamt@cdl2000.com).

2003-12-01  Dick Porter  <dick@ximian.com>

	* CultureInfo.cs: Culture name creation is case-insensitive.
	Implemented CurrentCulture and CurrentUICulture.

	* CompareInfo.cs: Fix IndexOf and LastIndexOf so that they work
	for combining characters.

2003-11-05  Pedro Martínez Juliá  <yoros@wanadoo.es>

	* DateTimeFormatInfo.cs: Hack an era for US culture. We must look
	for other ways to get the ERA string.

2003-10-21  Dick Porter  <dick@ximian.com>

	* TextInfo.cs: 
	* CultureInfo.cs: Implement TextInfo.GetHashCode().  Fixes bug
	49923.

2003-10-09  Dick Porter  <dick@ximian.com>

	* CultureInfo.cs: Implemented, with internal calls to ICU apart
	from the Invariant culture.
	
	* SortKey.cs:
	* CompareInfo.cs: Implemented

	* DateTimeFormatInfo.cs: Fixed the worst of the formatting,
	construct default FullDateTimePattern on the fly.

2003-08-06  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* Locale.cs: Removed (added new version to Assembly directory)

2003-07-23  Duncan Mak  <duncan@ximian.com>

	* DateTimeFormatInfo.cs: theInvariantDateTimeFormatInfo should not
	be public.

2003-05-11  Ben Maurer  <bmaurer@users.sourceforge.net>

	* *Calendar.cs: Implemented the TwoDigitYearMax property.
	
2003-04-22  Pedro Martínez Juliá  <yoros@wanadoo.es>

	* NumberFormatInfo.cs: Method CurrentInfo now returns the "real"
	CurrentInfo (Thread.CurrentThread.CurrentCulture.NumberFormat).

2003-02-27  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CultureInfo.cs:
	(NameToID): make it case insensitive and use a hashtable instead of
	comparing all the strings.

Mon Nov 18 13:02:09 CET 2002 Paolo Molaro <lupus@ximian.com>

	* CultureInfo.cs: implemented Equals and GetHashCode.

2002-10-17  Duncan Mak  <duncan@ximian.com>

	* CultureInfo.cs (TextInfo): return a TextInfo in the property.

	* TextInfo.cs (ToLower):
	(ToTitleCase): Implemented.

2002-09-12  Dick Porter  <dick@ximian.com>

	* ThaiBuddhistCalendar.cs: 
	* TextInfo.cs: 
	* TaiwanCalendar.cs: 
	* RegionInfo.cs: 
	* KoreanCalendar.cs: 
	* JulianCalendar.cs: 
	* JapaneseCalendar.cs: 
	* HijriCalendar.cs: 
	* HebrewCalendar.cs: 
	* GregorianCalendar.cs: 
	* CultureInfo.cs: 
	* CompareInfo.cs: Stub out missing methods

2002-08-15  Tim Coleamn <tim@timcoleman.com>
	* CompareInfo.cs:
		Stubbed out some methods.

2002-08-14  Dick Porter  <dick@ximian.com>

	* CultureInfo.cs: Implement Name, stub out all the other missing
	methods.

	* TextInfo.cs: Stubbed out this class

2002-06-12  Nick Drochak  <ndrochak@gol.com>

	* DateTimeFormatInfo.cs: Reformat.

2002-06-11  Nick Drochak  <ndrochak@gol.com>

	* NumberFormatInfo.cs: Make NumberNegativePattern = 1 for the ctor

2002-06-07  Nick Drochak  <ndrochak@gol.com>

	* NumberFormatInfo.cs: Make InvariantInfo.NumberNegativePattern = 1

2002-05-07  Rodrigo Moya <rodrigo@ximian.com>

	* CompareInfo.cs: new basic stub (compiles on Linux, so I assume
	it does not break the build on windows. Sorry if it does).

2002-04-23  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* NumberFormatInfo.cs: always set the values for the invariant culture
	until there are more cultures supported.

2002-04-22  Nick Drochak  <ndrochak@gol.com>

	* NumberStyles.cs: Add [Serializable].

2002-04-08  Nick Drochak  <ndrochak@gol.com>

	* UnicodeCategory.cs: Fix typos in enum names.

2002-03-04  Nick Drochak  <ndrochak@gol.com>

	* JulianCalendar.cs: JulianEra should be field, not a property.
	Thanks CorCompare (and Piers).

2002-02-12  Duncan Mak  <duncan@ximian.com>

	* CultureInfo.cs: Added the Calendar property to make the TimeZone
	class build. It's marked as MonoTODO.

2002-02-12  Nick Drochak  <ndrochak@gol.com>

	* UnicodeCategory.cs: Fix typo.

2002-02-01  Radek Doulik  <rodo@ximian.com>

	* RegionInfo.cs: started work on RegionInfo
	implemented RegionInfo (string) constructor

	* CultureInfo.cs: added internal static function,
	which could be used from RegionInfo.cs

2002-01-16  Miguel de Icaza  <miguel@ximian.com>

	* CultureInfo.cs: Completed the tables.   Now we need to actually
	fill it in.

2002-01-15  Duncan Mak  <duncan@ximian.com>

	* CultureInfo.cs: Convert it to unix text.

2002-01-04  Ravi Pratap  <ravi@ximian.com>

	* GreogrianCalendar.cs : The same old MonoTODO attribute.

2001-11-21  Miguel de Icaza  <miguel@ximian.com>

	* Locale.cs: New file, a place holder for Locale.GetText.

Wed Nov 14 16:47:07 CET 2001 Paolo Molaro <lupus@ximian.com>

	* Calendar.cs: CLSCompliant updates.

2001-11-04  Martin Weindel <martin.weindel@t-online.de>
        * NumberFormatInfo.cs: fixed minor bug in Clone with readonly flag

        * DateTimeFormatInfo.cs: added

        * CultureInfo.cs: some changed needed for compiling DateTimeFormatInfo.cs

2001-10-26  Miguel de Icaza  <miguel@ximian.com>

	* NumberFormatInfo.cs: Provide an internal constructor that takes
	as an argument a CultureInfo ID (LCID) so that we can construct
	different ones here.

	* CultureInfo.cs: Begun implementation.

2001-10-09  Derek Holden  <dholden@draper.com>

	* NumberFormatInfo.cs: Small typo in PercentPositivePattern
	and CurrencyPositivePattern

2001-09-02  Miguel de Icaza  <miguel@ximian.com>

	* Calendar.cs: Implement a bunch of missing features.

2001-07-24  Derek Holden  <dholden@draper.com>

	* NumberStyles.cs: Added ECMA values for Allow types and default
	styles.

2001-07-18  Michael Lambert <michaellambert@email.com>

        * DateTimeStyles.cs, NumberStyles.cs: Add.

